<?php
/*
 * This file is part of the easy-CMS project.
 * easy-CMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * easy-CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with easy-CMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// define the path context
chdir('..');
define('EASY_GUI_APP_DIR', '../');


include_once('config.inc.php');
include_once('classes/core/Site.class.php');

include_once('classes/system/Dir.class.php');
include_once('classes/system/File.class.php');


include_once('interface/egScript.class.php');
include_once('interface/egManager.class.php');
include_once('interface/egContainer.class.php');
include_once('interface/egMenuItem.class.php');
include_once('interface/egFrame.class.php');
include_once('interface/egToolTip.class.php');
include_once('interface/egRichText.class.php');
include_once('interface/egLink.class.php');
include_once('interface/egStatic.class.php');
include_once('interface/egEdit.class.php');
include_once('interface/egCheckBox.class.php');
include_once('interface/egRadioButton.class.php');
include_once('interface/egPressButton.class.php');
include_once('interface/egDropDownListBox.class.php');
include_once('interface/egPropertyList.class.php');
include_once('interface/egPropertySheet.class.php');
include_once('interface/egPropertyPage.class.php');
include_once('interface/egTreeNode.class.php');
include_once('interface/egTreeList.class.php');
include_once('interface/egSubWindow.class.php');


$site = &Site::getInstance(); // constructor checks the $_GET, $_POST and $_SESSION arrays

//security check : user must be identified to upload some file
$user = $site->getCurrentUser();
if(!$user || $user->getUserId() == USER_ID_ANONYMOUS) {
	die("access denied");
	exit();
}


$mode 		= $site->getSubmittedVar('mode', ASK_RENAME_FILE);
$path 	 	= $site->getSubmittedVar('path');
$newName 	= $site->getSubmittedVar('new_name');


if(!is_file($path)) {
	$mode = RENAME_FILE;
}

if(isset($newName) && !Node::isValidFileName($newName)) {
	// invalid filename : suggest alternate name
	$newName = Node::toValidName(strtolower(utf8_decode($newName)));
	$mode 	 = ASK_RENAME_FILE;
}


switch ($mode) {
	case ASK_RENAME_FILE :
		$manager = &egManager::getInstance(LANG_FILE_RENAME_TITLE);
		$main = &new egContainer("main_ctn", 0, 0, 0, 0);
		$manager->addContainer($main);

		$stringTxtValue = '';
		$stringTxtBold = false;
		if(isset($newName)) {
			$stringTxtValue = LANG_FILE_RENAME_INVALID;
			$stringTxtBold = true;
		}
		else {
			$stringTxtValue = LANG_FILE_RENAME_NEW_NAME;
		}

		$txtValue = &new egStatic("txt_value_1", $stringTxtValue, 10, 15, 350, 0, $stringTxtBold);
		$nameValue = &new egStatic("name_value_1", LANG_FILE_RENAME_NEW_NAME_STATIC.LANG_COLON, 10, 60, 100, 0, true);

		$node = &new File("", $path);
		$newNameString = $node->getName();
		if(isset($newName)) {
			$newNameString = $newName;
		}

		$newNameItem = &new egEdit("new_name_item", $newNameString, 110, 60, 200, 18, "new_name");

		$okButton = &new egPressbutton("btn_ok", LANG_OK_BUTTON, 150, 100, 80, null, "clickOKButton();");
		$cancelButton = &new egPressbutton("btn_cancel", LANG_CANCEL_BUTTON, 235, 100, 80, null, "clickCancelButton();");

		$hiddenValuesContainer = &new egContainer("ctn_hidden_values", 0, 0, 1, 1);

		$objMode = &new egEdit("hidden_control_mode", RENAME_FILE, 0, 0, 0, 0, "mode");
		$objPath = &new egEdit("hidden_control_path", $path, 0, 0, 0, 0, "path");

		$hiddenValuesContainer->addObject($objMode);
		$hiddenValuesContainer->addObject($objPath);

		$manager->addContainer($hiddenValuesContainer);

		$main->addObject($okButton);
		$main->addObject($cancelButton);

		$main->addObject($txtValue);
		$main->addObject($nameValue);
		$main->addObject($newNameItem);

		$scripts = &new egScript();
		$line = "function clickOKButton() {
document.forms[0].submit();
}
function clickCancelButton() {
window.close();
}
";
		$scripts->addLine($line);
		$manager->addScripts($scripts);

		print($manager->getHTML());

		break;
	case RENAME_FILE :
		if(is_file($path)) {
			$node = &new File("", $path);
      $dbManipulator = &$site->getDBManipulator();
      $result_array = $dbManipulator->getRecord(FRAMES_TABLE, -1, "`file`='".$node->getName()."'");
      if($row = $dbManipulator->fetchArray($result_array)) {
        $frame_id = $row['id'];
        $fields_array['file'] = $newName;
        $fields_array['name'] = substr($newName, 0, strrpos($newName, '.'));
        $dbManipulator->setRecord(FRAMES_TABLE, $frame_id, $fields_array);
      }
			$node->rename($newName);
		}

		$manager = &egManager::getInstance();
		$main = &new egContainer("main_ctn", 0, 0, 0, 0);
		$manager->addContainer($main);

		$scripts = new egScript();
		$line = "window.opener.location.reload();window.close();";
		$scripts->addLine($line);

		$manager->addScripts($scripts);
		print($manager->getHTML());

		break;
}
?>